SystemOrganization addCategory: #'Pier-CommandWidget'!

PRWidget subclass: #PRCommandWidget
	instanceVariableNames: 'command component useButton'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-CommandWidget'!

!PRCommandWidget class methodsFor: 'as yet unclassified' stamp: 'kph 9/22/2008 00:54'!
defaultCommandClasses
	^ (Array withAll: PRCommand withAllConcreteClasses)
		sort: [ :a :b | a label caseInsensitiveLessOrEqual: b label ];
		yourself! !

!PRCommandWidget class methodsFor: 'as yet unclassified' stamp: 'kph 9/22/2008 13:52'!
descriptionButton
	^ MABooleanDescription new
		default: false;
		accessor: #useButton;
		label: 'Button';
		priority: 210;
		yourself! !

!PRCommandWidget class methodsFor: 'as yet unclassified' stamp: 'kph 9/22/2008 00:53'!
descriptionCommandClass
	^ MASingleOptionDescription new
		default: [ self defaultCommandClasses first ] asDynamicObject;
		options: [ self defaultCommandClasses ] asDynamicObject;
		reference: MAClassDescription new;
		accessor: #commandClass;
		label: 'Command Class';
		priority: 200;
		yourself! !

!PRCommandWidget class methodsFor: 'as yet unclassified' stamp: 'kph 9/22/2008 00:57'!
isAbstract

	^ false! !

!PRCommandWidget class methodsFor: 'as yet unclassified' stamp: 'kph 9/22/2008 00:58'!
label

^ 'A Command'! !

!PRCommandWidget methodsFor: 'accessing' stamp: 'kph 9/22/2008 13:52'!
command
	"Answer the value of command"

	^ command! !

!PRCommandWidget methodsFor: 'accessing' stamp: 'kph 9/22/2008 13:52'!
command: anObject
	"Set the value of command"

	command := anObject! !

!PRCommandWidget methodsFor: 'as yet unclassified' stamp: 'kph 9/22/2008 00:53'!
commandClass 
	^ self read: #descriptionCommandClass! !

!PRCommandWidget methodsFor: 'accessing' stamp: 'kph 9/22/2008 13:52'!
component
	"Answer the value of component"

	^ component! !

!PRCommandWidget methodsFor: 'accessing' stamp: 'kph 9/22/2008 13:52'!
component: anObject
	"Set the value of component"

	component := anObject! !

!PRCommandWidget methodsFor: 'as yet unclassified' stamp: 'kph 9/22/2008 13:57'!
renderContentOn: html
  
	(self commandClass isValidIn: self context) ifFalse: [ ^ self ].
	 
	self useButton ifFalse: [
	
		html anchor
			class: 'internal';
			title: self owner title;
			goto: (self context command: self commandClass new);
			with: self owner title	

 	] ifTrue: [
	 
		html form
			with: [ html button
			class: 'internal';
			title: self owner title;
			goto:  (self context command: self commandClass new);
			with: self owner title ]
	].! !

!PRCommandWidget methodsFor: 'accessing' stamp: 'kph 9/22/2008 14:17'!
useButton
	^ self read: #descriptionButton! !
